;--------------------------------------------------------------------------
; Ben Weir
; CIS 35
; Assignment 5
;--------------------------------------------------------------------------
        .model small
        .stack 100h
        .data
True     equ 1
False    equ 0
DescTab  equ 8
PriceTab equ 22
ExtTab   equ 35
TotalTab equ 22
;
;
;
FName           db 'cis34inv.dat', 0    ;name of data file
FHandle         dw ?                    ;file handle
Eof             db False                ;end of file
UsrInvenNum     db 6 dup (?)            ;inventory number typed by user
Match           db False                ;true if inven # found in file
HeaderPrinted   db False                ;only want to print the header once
newline         db 10, 13, '$'          ;print to get to the next line

TitleMsg        db 'CIS 35 Inventory Program by Ben Weir', 10, 13, '$'
GoodbyeMsg      db 10, 13, 10, 13, 'Thank you for using the inventory program$'
InvenPrompt     db 10, 13, 'Please enter the Inventory Number: $'
QtyPrompt       db 10, 13, 'Please enter the quantity: $'
NotFoundMsg     db 10, 13, 'Inventory number not found!$'
TotalMsg        db 'Total: $'

InvoiceHeader   db ' Qty   Description    Price     Extension', 10, 13
                db '-----------------------------------------', 10, 13, '$'

QtyStr          db 5 dup (32), '$'
QtyNum          dw 0

PriceStr        db 5 dup (32), '$'
PriceNum        dw 0

ExtStr          db 5 dup (32), '$'
ExtNum          dw 0

TotalStr        db 5 dup (32), '$'
Totalnum        dw 0                    ;total bill

Prices          db 3, 6, 13             ;prices for levels 1, 2, and 3

FileInvenNum    db 6 dup (32), '$' ;dollar signs for easy printing
Description     db 11 dup (32), '$'

PriceLevel      db ?
pricelevelnum   db ?


        .code
        mov ax, @data
        mov ds, ax
        mov es, ax
  start:
        call Initialization

        call MainLoop

        call EndRoutine
  done:
        mov ax, 4c00h
        int 21h


MainLoop proc near
  startmain:
        lea dx, InvenPrompt            ;prompt them for the inventory number
        mov ah, 9
        int 21h

        mov cx, 6               ;max 6 chars
        lea si, UsrInvenNum
        call ReadString

        mov cx, 6
        lea si, UsrInvenNum

  nextcharmain:
        mov al, [si]
        cmp al, '0'             ;compare to '000000'
        jnz notzero

        inc si
        loop nextcharmain

        jmp exitmain

  notzero:
        call SearchFile         ;look for that inventory number in the file
        cmp Match, True
        jnz nomatchmain

        lea dx, qtyprompt       ;prompt them for the quantity
        mov ah, 9
        int 21h

        mov cx, 3
        lea si, QtyStr
        call ReadString         ;get the quantity from user

        lea si, QtyStr
        lea di, QtyNum
        mov cx, 3
        mov dl, 0
        call String2Num         ;convert quantity to numeric format

        mov ax, QtyNum
        mov bl, PriceLevelnum
        dec bl
        mov bh, 0
        mov dl, [Prices+bx]     ;get price
        mov PriceNum, dx        ;store price in memory

        mul dx                  ;multiply price by quantity to get extension

        mov ExtNum, ax          ;store extenstion in memory
        add TotalNum, ax           ; and add it to the total price

        Call PrintInvoice       ;display the invoice

        jmp startmain

  nomatchmain:
        lea dx, NotFoundMsg
        mov ah, 9
        int 21h         ;write 'not found' message
        jmp startmain   ;go back to the top


  exitmain:
        call PrintTotal         ;print the total price
        ret
MainLoop endp



SearchFile proc near
        call ResetFile
        mov match, false

  searchnextrecord:
        mov cx, 6
        lea dx, FileInvenNum            ;read the inventory number
        call ReadFile

        cmp eof, true
        jz endsearch                    ;exit loop if end of file reached

        cld
        lea si, UsrInvenNum
        lea di, FileInvenNum
        mov cx, 7
        repz cmpsb

        cmp cx, 0
        jz matchfound
        
        mov ah, 042h
        mov al, 1
        xor cx, cx
        mov dx, 12
        int 21h         ;increment file pointer by 12 to get to next record
        jmp searchnextrecord           ;repeat if match not found

  matchfound:      
        ;read rest of record because a match was found
        mov Match, true

        mov cx, 11
        lea dx, Description             ;read the description
        call ReadFile

        mov cx, 1
        lea dx, pricelevel              ;read the price level
        call ReadFile

        lea si, pricelevel
        lea di, pricelevelnum           ;convert price level to number
        mov dl, 0       
        call String2Num

  endsearch:

        ret
SearchFile endp



ReadFile proc near
;reads data from a file
;enter with cx: number bytes to read
;           dx: pointer to buffer to store data
;sets EOF true if end of file is reached

        mov bx, fhandle
        mov ah, 3fh
        int 21h
        cmp ax, cx
        jz readfileok
        mov Eof, true

  Readfileok:

        ret
ReadFile endp



PrintTotal proc near
;prints the total price after user enters '000000'
        cmp HeaderPrinted, True
        jnz noprinttotal

  yesprinttotal:
        lea bx, newline
        call PrintStr

        mov dh, TotalTab
        call SetPrinterPos
        lea bx, Totalmsg
        call PrintStr
        
        lea si, TotalNum
        lea di, TotalStr
        call Num2String         ;convert total to string
        lea bx, TotalStr
        call PrintStr           ;print total amount

  noprinttotal:
        ret
PrintTotal endp


PrintInvoice proc near
;prints one line of the invoice to the printer
        cmp HeaderPrinted, True
        jz noprintheader

  yesprintheader:
        lea bx, InvoiceHeader
        call PrintStr
        mov HeaderPrinted, True

  noprintheader:
        lea si, QtyNum
        lea di, QtyStr
        call Num2String
        lea bx, QtyStr
        call Printstr           ;print quantity

        mov dh, DescTab
        call SetPrinterPos
        lea bx, Description
        call PrintStr           ;print description

        mov dh, PriceTab
        call SetPrinterPos
        lea si, Pricenum
        lea di, Pricestr
        call Num2String
        lea bx, PriceStr
        call PrintStr           ;print price

        mov dh, ExtTab
        call SetPrinterPos
        lea si, ExtNum
        lea di, ExtStr
        call Num2String
        lea bx, ExtStr
        call PrintStr           ;print extension

        lea bx, NewLine
        call PrintStr           ;go to next line

        ret
PrintInvoice endp



SetPrinterPos proc near
;positions printer in column DH on current line
        push cx
        mov cl, dh
        mov ch, 0
        mov ah, 5

        mov dl, 13              ;send CR
        int 21h

        mov dl, 32
  nextprinterpos:
        int 21h
        loop nextprinterpos     ;print DH spaces

        pop cx
        ret
SetPrinterPos endp



Printstr proc near
;sends a string to the printer
;string is pointed to by DS:BX and terminated by a '$'
        push ax

        mov ah, 5               ;print char function

  nextchar:
        mov dl, [bx]
        cmp dl, '$'             ;quit when '$' encountered
        jz endstr
        int 21h                 ;send it to printer
        inc bx
        jmp nextchar
  endstr:

        pop ax
        ret
Printstr endp




String2Num proc near
;converts a string to a number
;enter with si: pointing to string
;           di: pointing to place where number will go
;returns numeric value (word) at DI
        push cx
        push dx
        mov ax, 0
        mov cx, 5               ;max of 5 characters to represent a word
  nextchars2n:
        mov dl, [si]
        cmp dl, 30h
        jl badchar

        cmp dl, 39h
        jg badchar

  okchar:
        and dl, 15
        mov dh, 0

        push dx
        mov dx, 10
        mul dx
        pop dx

        add ax, dx
        inc si
        loop nextchars2n

  badchar:
        mov [di], ax           ;store the result in memory

  ends2n:
        pop dx
        pop cx
        ret
String2Num endp


Num2String proc near
;converts a number (byte) into a string
;enter with si: pointing to number (word) to convert
;           di: pointing to buffer to store string
;returns string at DI

        cld
        mov cx, 5
        mov al, 32               ;fill string with spaces
        rep stosb

        mov cx, 5
        dec di                  ;point to last character in string

        mov ax, [si]
  loopn2s:
        mov bl, 10
        div bl                  ;ah := ax div 10
        add ah, 30h             ;ax := ax + 30h
        mov [di], ah            ;store it in memory
        dec di
        mov ah, 0
        cmp al, 0               ;go until the division results in < 1
        loopnz loopn2s          ; or 5 spaces filled


        ret
Num2String endp



ResetString proc near
;input  cx:length
;       di:location of buffer
        push cx
        push di
        
        cld
        mov al, ' '
        rep stosb
        
        pop di
        pop cx
        ret
ResetString endp

ResetFile proc near
;sets file pointer to beginning of file
        push bx
        push cx
        push dx

        mov eof, false          ;erase end of file flag
        mov bx, Fhandle
        mov al, 0
        mov ah, 42h
        xor cx, cx              ;set cx, dx = 0
        xor dx, dx              ;move file pointer to 0 (start of file)
        int 21h

        pop dx
        pop cx
        pop bx
        
        ret
ResetFile endp

Initialization proc near
        lea dx, TitleMsg
        mov ah, 9
        int 21h                 ;print welcome message

        mov ah, 3dh
        mov al, 11000000b       ;read only
        lea dx, FName           ;point to filename
        int 21h                 ;open file function
        mov FHandle, ax         ;store file handle for future reference
        ret
Initialization endp

EndRoutine proc near
        lea dx, GoodbyeMsg
        mov ah, 9
        int 21h                 ;print goodbye message

        mov ah, 3eh
        mov bx, FHandle
        int 21h                 ;close file function
        ret
EndRoutine endp

readstring proc near
;enter with cx: number of characters to read
;           si: offset of place to store string
;returns    ax: number of chars entered
        
        push cx
        push si
        mov di, si
        call ResetString

        mov bx, si              ;save starting address

  readnewchar:
        mov ah, 8               ;char input without echo
        int 21h

        cmp al, 0dh
        jz stringdone           ;exit if they press enter

        cmp al, 8
        jz backspace            ;don't add the character if it's BS

        mov dl, al
        mov ah, 2
        int 21h                 ;show character

        mov [si], al            ;store it in buffer
        inc si
        loop readnewchar

        jmp stringdone

  backspace:
        cmp si, bx               ;don't want to backspace
        jle nomorebs             ;past start of string
        dec si
        mov byte ptr [si], 0
        mov ah, 2
        mov dl, 8
        int 21h
        mov dl, 20h             ;erase character with ' ' and another BS
        int 21h
        mov dl, 8
        int 21h
        inc cx
  nomorebs:
        cmp cx, 0
        jnz readnewchar

  stringdone:
        mov ax, si
        sub ax, bx              ;get total chars entered in AX

        pop si
        pop cx
        ret
readstring endp

        end
